# Custom Logging - Documents > References


## Description
Various references used in project.


## References

### General (NodeJs) JavaScript References
#### JavaScript Variables - Var, Let, and Const
<https://www.w3schools.com/js/js_let.asp><br>
<https://www.w3schools.com/js/js_const.asp><br>
<https://www.freecodecamp.org/news/var-let-and-const-whats-the-difference/><br>
TLDR: Use `let` whenever possible. It's better.

#### Returning Multiple Values from a Function
<https://www.javascripttutorial.net/javascript-return-multiple-values/>

#### Importing Multiple Values from a File
<https://stackoverflow.com/a/16631079>

#### JavaScript Classes
<https://www.w3schools.com/js/js_classes.asp>
<https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Classes>

#### JavaScript Class Private Variables
<https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Classes/Private_class_fields>

#### JavaScript Singletons
<https://medium.com/swlh/node-js-and-singleton-pattern-7b08d11c726a>

#### JavaScript Check if Type String
<https://stackoverflow.com/a/9436948>

#### Checking Last Value in String
<https://stackoverflow.com/a/3884711>

### Logging References
#### Official NodeJS Logging Docs
<https://nodejs.org/docs/latest/api/console.html>

#### More on JavaScript Logging
<https://stackify.com/javascript-logging-basic-tips/>

#### Creating a New Console Object
<https://www.geeksforgeeks.org/node-js-new-console-method/>

#### Rework Logging to Output Line #, File Name, and Color Output
<https://stackoverflow.com/a/60305881>

#### Python Logging Levels
Used as reference to help determine values used here.<br>
<https://docs.python.org/3/library/logging.html>
