# JavaScript - Custom Logger


## Description
Custom logging file to be imported into other projects.

Improves logging handling above and beyond JavaScript's default definitions.


## Importing to Another Project
To use project, copy over the `src/logging.js` file, as well as the `src/helper_functions.js` file. Make sure to also
include and install dependencies as defined in `package.json`.

Then, in any desired files, add `require('<path_to_logging.js>');` to the top of the file.


## Program Setup
Install NodeJs. Then run `npm install` at project root to install dependencies.


## Running the Program
Once the program is setup, run `node app.js` from project root.


## References
See `documents/references.md` for various references used for project.
